//
//  ViewController.m
//  MyTest4
//
//  Created by 孙桂山 on 2017/12/5.
//  Copyright © 2017年 孙桂山. All rights reserved.
//

#import "ViewController.h"
#import "ivr4pengine.h"

@interface ViewController
(
 )
@property (nonatomic , strong) EAGLContext* mContext;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    [self setupConfig];
    
    V4_CfgSetGlassMode(true);
    
    V4_CfgSetFovV(3.14159265f * 80.f / 180.f);
    V4_CfgSetUndistortParam(0.180f, 0.20f);
    V4_CfgSetGlassViewPortScale(1.0364f);
    V4_CfgSetCenterOffset(90,20);
    V4_CfgSetCenterBlackWidth(33);
    
    //V4_CfgSetFovV(3.14159265f * 50.41f / 180.f);
    //V4_CfgSetUndistortParam(0.112f, 0.00f);
    //V4_CfgSetGlassViewPortScale(1.06f);
    //V4_CfgSetCenterOffset(5,0);
    
    V4_PlayVRV("OlympicForestPark_3X3_2018.vrv", "114.215.109.229", 12486, true, "");
    //V4_PlayVRV("insta36B_2018.vrv", "114.215.109.229", 12486, true, "");
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)setupConfig
{
    self.mContext = [[EAGLContext alloc] initWithAPI:kEAGLRenderingAPIOpenGLES2]; //2.0，还有1.0和3.0
    GLKView* view = (GLKView *)self.view;
    view.context = self.mContext;
    view.drawableColorFormat = GLKViewDrawableColorFormatRGBA8888;  //颜色缓冲区格式
    view.drawableDepthFormat = GLKViewDrawableDepthFormatNone;
    view.drawableStencilFormat = GLKViewDrawableStencilFormat8;     //必须 ，千万不能少
    self.preferredFramesPerSecond = 60;
    [EAGLContext setCurrentContext:self.mContext];
}


- (void)glkView:(GLKView *)view drawInRect:(CGRect)rect
{
    static GLint s_backingWidth = -1;
    static GLint s_backingHeight = -1;
    
    GLint _backingWidth = 0;
    GLint _backingHeight = 0;
    
    glGetRenderbufferParameteriv(GL_RENDERBUFFER, GL_RENDERBUFFER_WIDTH, &_backingWidth);
    glGetRenderbufferParameteriv(GL_RENDERBUFFER, GL_RENDERBUFFER_HEIGHT, &_backingHeight);
    
    if(s_backingWidth != _backingWidth || s_backingHeight != _backingHeight)
    {
        V4_ResizeMyGL(_backingWidth, _backingHeight);
        s_backingWidth = _backingWidth;
        s_backingHeight = _backingHeight;
        NSLog(@"_backingWidth=%d _backingHeight=%d",_backingWidth,_backingHeight);
    }
    
    V4_PreRender();
    if(V4_CfgGetGlassMode())
    {
        if(V4_RenderScene(g_iRenderScene_VRLeft))
        {
            //V4_Render3DUI(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3DRectPos#>, <#bool bOpacity#>, <#int iTextureHandle#>)
            //V4_Render3DUI2(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3CenterPos#>, <#bool bVertical#>, <#float fWidth#>, <#float fHeight#>, <#float fRotateAngle#>, <#bool bOpacity#>, <#int iTextureHandle#>)
            //V4_Render3DProgressCircle(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3CenterPos#>, <#bool bVertical#>, <#float fWidth#>, <#float fRotateAngle#>, <#int iTextureHandle#>)
            //绘制3d界面
        }
        if(V4_RenderScene(g_iRenderScene_VRRight))
        {
            //V4_Render3DUI(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3DRectPos#>, <#bool bOpacity#>, <#int iTextureHandle#>)
            //V4_Render3DUI2(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3CenterPos#>, <#bool bVertical#>, <#float fWidth#>, <#float fHeight#>, <#float fRotateAngle#>, <#bool bOpacity#>, <#int iTextureHandle#>)
            //V4_Render3DProgressCircle(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3CenterPos#>, <#bool bVertical#>, <#float fWidth#>, <#float fRotateAngle#>, <#int iTextureHandle#>)
            //绘制3d界面
        }
    }
    else
    {
        if(V4_RenderScene(g_iRenderScene_NoGlass))
        {
            //V4_Render3DUI(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3DRectPos#>, <#bool bOpacity#>, <#int iTextureHandle#>)
            //V4_Render3DUI2(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3CenterPos#>, <#bool bVertical#>, <#float fWidth#>, <#float fHeight#>, <#float fRotateAngle#>, <#bool bOpacity#>, <#int iTextureHandle#>)
            //V4_Render3DProgressCircle(<#bool bLeftEye#>, <#float fEyeOffset#>, <#float *f3CenterPos#>, <#bool bVertical#>, <#float fWidth#>, <#float fRotateAngle#>, <#int iTextureHandle#>)
            //绘制3d界面
        }
    }
    V4_AftRender();
    //
    //绘制2D界面
    //
    //V4_Render2DUI(<#float fCenterXInP#>, <#float fCenterYInP#>, <#float fWidthInP#>, <#float fHeightInP#>, <#float fRotateAngle#>, <#bool bOpacity#>, <#int iTextureHandle#>)
}


@end



